/// <reference path="../../web1/lib1/innovaphone.lib1.js" />
/// <reference path="../../web1/appwebsocket/innovaphone.appwebsocket.Connection.js" />
/// <reference path="../../web1/ui1.lib/innovaphone.ui1.lib.js" />
var startCall;
var lastCall;
var userCallUser;
var sourceNumber;
var hangupCall;
var connectCall;
var innovaphoneAddress;
var language;
var device;
var setDevice;

var jtel = jtel || {};
jtel.jtelsalesforce = jtel.jtelsalesforce || function(start, args) {
    this.createNode("body");
    var that = this;

    var colorSchemes = {
        dark: {
            "--bg": "#191919",
            "--button": "#303030",
            "--text-standard": "#f2f5f6",
        },
        light: {
            "--bg": "#191919",
            "--button": "#303030",
            "--text-standard": "#f2f5f6",
        }
    };
    var schemes = new innovaphone.ui1.CssVariables(colorSchemes, start.scheme);
    start.onschemechanged.attach(function() {
        schemes.activate(start.scheme)
    });

    var texts = new innovaphone.lib1.Languages(jtel.jtelsalesforceTexts, start.lang);
    start.onlangchanged.attach(function() {
        texts.activate(start.lang)
    });

    language = start.lang;

    document.getElementById('login-btn').innerHTML = jtel.jtelsalesforceTexts[language]['login'];

    document.getElementById('addr').setAttribute("placeholder", jtel.jtelsalesforceTexts[language]['enterAddr']);
    document.getElementById('usr').setAttribute("placeholder", jtel.jtelsalesforceTexts[language]['enterUsr']);
    document.getElementById('pwd').setAttribute("placeholder", jtel.jtelsalesforceTexts[language]['enterPwd']);
}

function innovaphoneLink() {
    return "https://" + innovaphoneAddress;
}

function RCC(addr, usr, pwd, out) {
    var body = document.getElementsByTagName("body");
    body[0].setAttribute("style", "background-color:#191919; max-width:500px")
    var panel = document.createElement("div");
    body[0].appendChild(panel);

    var users = [];

    var ws = new WebSocket("wss://" + addr + "/PBX0/APPS/websocket");
    out.innerHTML = null;

    ws.onopen = function() {
        ws.send(JSON.stringify({
            mt: "AppChallenge"
        }));
    }

    ws.onmessage = function(message) {
        var obj = JSON.parse(message.data);
        console.debug(obj);
        if (obj.mt && obj.mt == "AppChallengeResult") {
            var digest = innovaphone.crypto.sha256("::" + usr + ":::" + obj.challenge + ":" + pwd);
            ws.send(JSON.stringify({
                mt: "AppLogin",
                sip: usr,
                digest: digest
            }));
        } else if (obj.mt && obj.mt == "AppLoginResult") {
            if (obj.ok) {
                doLogin();
                initializeSalesforce();
            } else outp("loginFailed");
            ws.send(JSON.stringify({
                mt: "Initialize",
                api: "RCC",
                calls: true
            }));
            ws.send(JSON.stringify({
                mt: "Devices",
                api: "RCC",
                cn: usr
            }));
            ws.send(JSON.stringify({
                mt: "UserInitialize",
                api: "RCC",
                cn: usr,
                xfer: true,
            }));
        } else if (obj.mt && obj.mt == "InitializeResult") {
            console.log("jtel: RCC initialized");
        } else if (obj.mt && obj.mt == "UserInitializeResult") {
            userCallUser = obj.user;
        } else if (obj.mt && obj.mt == "UserCallResult") {
            lastCall = obj.call;
        } else if (obj.mt == "UserInfo" && obj.h323 == usr) {
            var u = users.find(function(e) {
                return obj.guid == e.guid()
            });
            if (!u && obj.update == 'add') {
                users.push(new User(obj));
                sourceNumber = obj.e164 ? obj.e164 : '0'; //what to do if user has no phone extention (e164)
            } else {
                if (obj.update == "del") {
                    users.splice(users.indexOf(u), 1);
                    u.del();
                } else {
                    u.update(obj);
                }
            }
        } else if (obj.mt == "CallInfo" && userCallUser == obj.user) {
            if (obj.msg == "x-alert" || obj.msg == "del") {
                users[0].updateCallInfo(obj);
                lastCall = obj.call;
            }
        }
    }

    ws.onerror = function() {
        outp("websocketError");
    }

    ws.onclose = function() {
        while (users.length) {
            var u = users.pop();
            u.del();
        }
        outp("websocketClose");
    }

    function User(info) {
        var userStatusDiv = document.createElement("div");
        userStatusDiv.setAttribute("id", "user-status");
        userStatusDiv.setAttribute("style", "border-radius:4px; height:15px; margin:10px; padding:10px");
        panel.appendChild(userStatusDiv);

        var deviceControlDiv = document.createElement("div");
        deviceControlDiv.setAttribute("id", "device-control");
        panel.appendChild(deviceControlDiv);

        var devicesRadioDiv = document.createElement("div");
        devicesRadioDiv.setAttribute("id", "devices-radio");
        devicesRadioDiv.setAttribute("style", "color:#F17735; margin-left:10px;");
        devicesRadioDiv.innerHTML = jtel.jtelsalesforceTexts[language]['selectDevice'];
        devicesRadioDiv.style.display = "none";
        deviceControlDiv.appendChild(devicesRadioDiv);

        var phoneNumberDiv = document.createElement("div");
        phoneNumberDiv.setAttribute("id", "phone-number");
        phoneNumberDiv.setAttribute("style", "display:flex");
        deviceControlDiv.appendChild(phoneNumberDiv);

        var phoneNumberInput = document.createElement("input");
        phoneNumberInput.setAttribute("id", "phone-number-input");
        phoneNumberInput.setAttribute("placeholder", jtel.jtelsalesforceTexts[language]['destNum'] + "...");
        phoneNumberInput.setAttribute("style", "border-radius:4px; width:215px; height:15px; margin:10px; padding:10px");
        phoneNumberDiv.appendChild(phoneNumberInput);

        var incomingCallInfoDiv = document.createElement("div");
        incomingCallInfoDiv.setAttribute("id", "incoming-call-info");
        incomingCallInfoDiv.setAttribute("style", "border-radius:5px; width:200px; height:35px; margin:10px; padding:10px; background-color:#f59b10; display:none; text-align:center");
        deviceControlDiv.appendChild(incomingCallInfoDiv);

        var callButtonsDiv = document.createElement("div");
        callButtonsDiv.setAttribute("id", "call-buttons");
        deviceControlDiv.appendChild(callButtonsDiv);

        var startCallBtn = (document.getElementById("call-button")).cloneNode(true);
        startCallBtn.setAttribute("style", "border-radius:1px; width:60px; height:30px; margin:10px; border:none; background-color:#7cb270");
        startCallBtn.setAttribute("onclick", "startCall()");
        callButtonsDiv.appendChild(startCallBtn);

        var hangupCallBtn = (document.getElementById("hangup-button")).cloneNode(true);
        hangupCallBtn.setAttribute("style", "border-radius:1px; width:60px; height:30px; margin:10px; border:none; background-color:#ef4d64; float:right");
        hangupCallBtn.setAttribute("onclick", "hangupCall()");
        callButtonsDiv.appendChild(hangupCallBtn);

        update();

        function update() {
            userStatusDiv.innerHTML = info.dn ? info.dn : info.cn;
            if (info.alert) userStatusDiv.style.backgroundColor = "#f59b10"; //yellow
            else if (info.channel) userStatusDiv.style.backgroundColor = "#ef4d64"; //red
            else if (info.regs) {
                userStatusDiv.style.backgroundColor = "#7cb270"; //green
                deviceControlDiv.style.display = "block";
                updateRadio(info.regs);
            } else {
                userStatusDiv.style.backgroundColor = "grey";
                userStatusDiv.innerHTML += " - " + jtel.jtelsalesforceTexts[language]['noDevice'];
                deviceControlDiv.style.display = "none";
            }
        }

        function updateCallInfo() {
            if (callInfo.msg == "x-alert") {
                incomingCallInfoDiv.style.display = "block";
                var peer = callInfo.peer.dn ? callInfo.peer.dn : callInfo.peer.cn;
                incomingCallInfoDiv.innerHTML = jtel.jtelsalesforceTexts[language]['innCallFrom'] + String(peer);
                jtelSalesForce_InboundCallNotification(callInfo.peer.e164, '');
            } else if (callInfo.msg == "del") {
                incomingCallInfoDiv.innerHTML = "";
                incomingCallInfoDiv.style.display = "none";
            }
        }

        function updateRadio(regs) {
            if (regs.length > 1) {
                devicesRadioDiv.style.display = "block";
                regs.forEach(function(reg, index) {
                    if (!document.getElementById("device-radio-input-" + index)) {
                        var deviceRadioDiv = document.createElement("div");
                        var deviceRadioInput = document.createElement("input");
                        deviceRadioInput.setAttribute("id", "device-radio-input-" + index);
                        deviceRadioInput.setAttribute("type", "radio");
                        deviceRadioInput.setAttribute("name", "hw");
                        deviceRadioInput.setAttribute("value", reg.hw);
                        deviceRadioInput.setAttribute("onclick", "setDevice(" + index + ")");
                        if (index == 0) {
                            deviceRadioInput.setAttribute("checked", "checked");
                            device = reg.hw;
                        }
                        var deviceRadioLabel = document.createElement("label");
                        deviceRadioLabel.setAttribute("for", deviceRadioInput.id);
                        deviceRadioLabel.setAttribute("style", "color:white");
                        deviceRadioLabel.innerHTML = deviceRadioInput.value;
                        deviceRadioDiv.appendChild(deviceRadioInput);
                        deviceRadioDiv.appendChild(deviceRadioLabel);
                        devicesRadioDiv.appendChild(deviceRadioDiv);
                    }
                });
            } else {
                devicesRadioDiv.style.display = "none";
                device = regs[0].hw;
            }
            console.log("jtel: selected Device " + device);
        }

        this.update = function(i) {
            info = i;
            update();
        }

        this.updateCallInfo = function(i) {
            callInfo = i;
            updateCallInfo();
        }

        this.del = function() {
            panel.removeChild(userStatusDiv);
        }

        this.guid = function() {
            return info.guid
        };
    }

    function doSetDevice(index) {
        device = document.getElementById('device-radio-input-' + index).value;
    }

    setDevice = doSetDevice;

    function outp(text) {
        var div = document.createElement("div");
        div.innerHTML = jtel.jtelsalesforceTexts[language][text];
        out.appendChild(div);
    }

    function doLogin() {
        innovaphoneAddress = document.getElementById('addr').value;
        document.getElementById('login-div').remove();
        document.getElementById('logout-btn').innerHTML = jtel.jtelsalesforceTexts[language]['logout'];
        document.getElementById('logout-btn').style.display = "block";
        document.getElementById('inno-link').innerHTML = jtel.jtelsalesforceTexts[language]['openInnoLink'];
        document.getElementById('inno-link').style.display = "block";
    }

    function doStartCall() {
        //check if there is a present call -> connectCall
        if (document.getElementById('incoming-call-info').style.display == "block") {
            doConnectCall();
        } else {
            var dest = document.getElementById('phone-number-input').value;
            console.log("jtel: doStartCall - dest=" + dest + " src=" + sourceNumber + " on device=" + device);
            if (dest != null && dest != '') {
                ws.send(JSON.stringify({
                    mt: "UserCall",
                    api: "RCC",
                    user: userCallUser,
                    ftyNoCF: false,
                    audio: true,
                    e164: dest,
                    srce164: sourceNumber,
                    hw: device
                }));
            }
        }
    }

    startCall = doStartCall;

    function doHangupCall() {
        console.log("jtel: doHangupCall - lastCall=" + lastCall);
        ws.send(JSON.stringify({
            mt: "UserClear",
            api: "RCC",
            call: lastCall
        }));
    }

    hangupCall = doHangupCall;

    function doConnectCall() {
        console.log("jtel: doconnectCall - lastCall=" + lastCall);
        ws.send(JSON.stringify({
            mt: "UserConnect",
            api: "RCC",
            call: lastCall
        }));
    }

    ////////////////////////////

    var jtelSalesForce_LogCallback = function(response) {
        console.log("jtel: jtelSalesForce_LogCallback - response = ", response);
    };

    var jtelSalesForce_OnAppViewInfoListener = function(response) {
        console.log('jtel: jtelSalesForce_OnAppViewInfoListener success = ' + response.success);
        var temp = document.createElement("a");
        temp.href = response.returnValue.url;
        console.log('jtel: jtelSalesForce_OnAppViewInfoListener jtelSalesForce_pageInfoData = ' + JSON.stringify(response.returnValue));
    };

    var jtelSalesForce_OnClickToDialListener_Lightning = function(response) {
        num = response.number;
        console.log('jtel: jtelSalesForce_OnClickToDialListener_Lightning - User clicked on a phone number ' + num + ', response = ' + JSON.stringify(response));
        document.getElementById('phone-number-input').value = num;
        console.log("jtel: Start Call");
        doStartCall();
    };

    var jtelSalesForce_ClickToDialCallback_Lightning = function(response) {
        if (response.success) {
            console.log('jtel: jtelSalesForce_ClickToDialCallback_Lightning - Click to dial was enabled.');
        } else {
            console.log('jtel: jtelSalesForce_ClickToDialCallback_Lightning - ERROR: Click to dial was NOT enabled - try again in 5 seconds.');
            setTimeout(function() {
                sforce.opencti.enableClickToDial(jtelSalesForce_ClickToDialCallback_Lightning);
            }, 5000);
        }
    };

    var jtelSalesForce_notifyInitializationCompleteCallback_Lightning = function(response) {
        if (response.success) {
            console.log('jtel: jtelSalesForce_notifyInitializationCompleteCallback_Lightning - Initialization complete was processed.');
        } else {
            console.log('jtel: jtelSalesForce_notifyInitializationCompleteCallback_Lightning - ERROR: Initialization complete was NOT processed - try again in 5 seconds.');
            setTimeout(function() {
                jtelSalesForce_InitialiseSalesForce('callback');
            }, 5000);
        }
    };

    function jtelSalesForce_screenPopOnCallerNumberOrSalesForceID(callerNumber, salesForceID, direction) {
        if (typeof sforce == 'undefined') return;
        if ((salesForceID != null) && (salesForceID != '')) {
            if (typeof sforce.opencti !== 'undefined') {
                // Lightning
                console.log("jtel: Lightning: jtelSalesForce_screenPopOnCallerNumberOrSalesForceID - sforce.opencti.screenPop( { type: sforce.opencti.SCREENPOP_TYPE.SOBJECT, params: { recordId: " + salesForceID + " }, callback: jtelSalesForce_LogCallback } )");
                sforce.opencti.screenPop({
                    type: sforce.opencti.SCREENPOP_TYPE.SOBJECT,
                    params: {
                        recordId: salesForceID
                    },
                    callback: jtelSalesForce_LogCallback
                });
            } else {
                // Classic
                console.log("jtel: Classic: jtelSalesForce_screenPopOnCallerNumberOrSalesForceID - sforce.interaction.screenPop( /" + salesForceID + ", true, jtelSalesForce_LogCallback )");
                sforce.interaction.screenPop('/' + salesForceID, true, jtelSalesForce_LogCallback);
            }
        } else {
            if (typeof sforce.opencti !== 'undefined') {
                // Lightning			
                console.log("jtel: Lightning: jtelSalesForce_screenPopOnCallerNumberOrSalesForceID - sforce.opencti.searchAndScreenPop( { searchParams : " + callerNumber + ", queryParams : '', callType : sforce.opencti.CALL_TYPE.INBOUND,  deferred: false, callback : jtelSalesForce_LogCallback } ");
                sforce.opencti.searchAndScreenPop({
                    searchParams: callerNumber,
                    queryParams: '',
                    callType: sforce.opencti.CALL_TYPE.INBOUND,
                    deferred: false,
                    callback: jtelSalesForce_LogCallback
                });
            } else {
                // Classic
                console.log("jtel: Classic: jtelSalesForce_screenPopOnCallerNumberOrSalesForceID - sforce.interaction.searchAndScreenPop( " + callerNumber + ", '', " + direction + ", jtelSalesForce_LogCallback )");
                sforce.interaction.searchAndScreenPop(callerNumber, '', direction, jtelSalesForce_LogCallback);
            }
        }
        if (typeof sforce.opencti !== 'undefined') {
            // Lightning - popup jtel client
            sforce.opencti.setSoftphonePanelVisibility({
                visible: true,
                callback: jtelSalesForce_LogCallback
            });
        }
    }

    var jtelSalesForce_InboundCallNotification = function(callerNumber, callInfo) {
        console.log("jtel: jtelSalesForce_InboundCallNotification( " + callerNumber + ", " + callInfo + " )");
        // Must be "inbound". "outbound" does not cause screen pop to occur
        jtelSalesForce_screenPopOnCallerNumberOrSalesForceID(callerNumber, callInfo, "inbound");
    };

    var jtelSalesForce_OutboundCallNotification = function(callerNumber, callInfo) {
        console.log("jtel: jtelSalesForce_OutboundCallNotification( " + callerNumber + ", " + callInfo + " ) ");
        // Must be "inbound". "outbound" does not cause screen pop to occur
        jtelSalesForce_screenPopOnCallerNumberOrSalesForceID(callerNumber, callInfo, "inbound");
    };

    function initializeSalesforce() {
        if ((typeof sforce !== 'undefined') && (typeof sforce.opencti !== 'undefined')) {
            // Lightning
            console.log("jtel: - sforce.opencti defined - SalesForce LIGHTNING");
            document.documentElement.style.height = 'calc( 100% - 1px )';
            console.log("jtel: sforce.opencti.getAppViewInfo( { callback: jtelSalesForce_OnAppViewInfoListener } );");
            sforce.opencti.getAppViewInfo({
                callback: jtelSalesForce_OnAppViewInfoListener
            });
            console.log("jtel: sforce.opencti.onClickToDial( jtelSalesForce_OnClickToDialListener_Lightning );");
            sforce.opencti.onClickToDial({
                listener: jtelSalesForce_OnClickToDialListener_Lightning
            });
            console.log("jtel: sforce.opencti.enableClickToDial( jtelSalesForce_ClickToDialCallback_Lightning );");
            sforce.opencti.enableClickToDial({
                callback: jtelSalesForce_ClickToDialCallback_Lightning
            });
            console.log("jtel: sforce.opencti.notifyInitializationComplete( jtelSalesForce_notifyInitializationCompleteCallback_Lightning );");
            sforce.opencti.notifyInitializationComplete(jtelSalesForce_notifyInitializationCompleteCallback_Lightning);
        } else {
            console.log("jtel: - sforce == undefined (no action)");
        }
    }
}

jtel.jtelsalesforce.prototype = innovaphone.ui1.nodePrototype;